/****************************************************************************/
/* Ώۃ}CR R8C/M12A                                                    */
/* ̧ٓe     t䃉Cu                                          */
/* o[W   Ver.1.00                                                    */
/* Date         2012.04.05                                                  */
/* Copyright    lTX}CRJ[[                            */
/****************************************************************************/

/*======================================*/
/* CN[h                         */
/*======================================*/
#include "sfr_r8m12a.h"                 /* R8C/M12A SFR̒`t@C   */
#include "lcd_lib.h"                    /* t䃉Cu           */

/************************************************************************/
/* 1ms̃EGCg                                                        */
/* @ [ms]                                                      */
/* ߂l Ȃ                                                          */
/************************************************************************/
static void lcd_wait( unsigned int msec )
{
    int tmp;

    while( msec > 0 ) {
        for( tmp = 0 ; tmp < 1000 ; tmp++);
        msec--;
    }
}

/************************************************************************/
/* t 4rbgM                                                     */
/* @ char bitdata : DB7`DB4ɐݒ肷f[^                       */
/* ߂l Ȃ                                                          */
/************************************************************************/
static void lcd_put_4bit( char data )
{
    int i;

    /* DB7`DB4̐ݒ */
    LCD_DB7 = (data & 0x08) ? 1 : 0;
    LCD_DB6 = (data & 0x04) ? 1 : 0;
    LCD_DB5 = (data & 0x02) ? 1 : 0;
    LCD_DB4 = (data & 0x01) ? 1 : 0;

    LCD_E = 1;                          /* ENABLE = H                   */
    for(i=0; i<50; i++);

    LCD_E = 0;                          /* ENABLE = L                   */
    for(i=0; i<50; i++);
}

/************************************************************************/
/* t                                                           */
/* @ Ȃ                                                          */
/* ߂l Ȃ                                                          */
/************************************************************************/
void lcd_init( void )
{
    lcd_wait( 15 );
    LCD_RS = 0;                         /* DB7`DB0̓R}h           */
    lcd_put_4bit( 0x3 );                /* Function Set Mode            */
    lcd_wait(4);
    lcd_put_4bit( 0x3 );
    lcd_wait(1);
    lcd_put_4bit( 0x3 );
    lcd_put_4bit( 0x2 );                /* Function Set Mode=4bit       */

    lcd_control( 0x28 );                /* Mode=4bit,Line=2,Font=5x7dot */
    lcd_control( LCD_CURSOR_OFF );      /* or LCD_CURSOR_ON             */
    lcd_control( LCD_CURSOR_INC );
    lcd_control( LCD_CLEAR );
}

/************************************************************************/
/* t 1oCgM                                                     */
/* @ char data tփf[^M                                    */
/* ߂l Ȃ                                                          */
/************************************************************************/
static void lcd_put_ch(char data)
{
    int i;

    lcd_put_4bit( data >> 4 );          /* 4rbgM              */
    lcd_put_4bit( data & 0x0f );        /* 4rbgM              */

    lcd_wait( 1 );
}

/************************************************************************/
/* t\ʒu̐ݒ                                                   */
/* @ char s(0`15), char (0`1)                             */
/* ߂l Ȃ                                                          */
/************************************************************************/
void lcd_position( char x ,char y )
{
    LCD_RS = 0;                         /* DB7`DB4̓R}h           */

    lcd_put_ch(0x80 | x | (0x40 * y));  /* AhXZbg               */
}

/************************************************************************/
/* tR}h̐ݒ                                               */
/* @ char s(0`15), char (0`1)                             */
/* ߂l Ȃ                                                          */
/************************************************************************/
void lcd_control( unsigned char data )
{
    LCD_RS = 0;                         /* DB7`DB4̓R}h           */

    lcd_put_ch( data );
    lcd_wait( 2 );
}

/************************************************************************/
/* tɐli10ij\                                           */
/* @ long \鐔l, int (1`8)                             */
/* ߂l Ȃ                                                          */
/************************************************************************/
void lcd_put_num( long value, int keta )
{
    long temp = 0;
    int i = keta-1;

    LCD_RS = 1;                         /* DB7`DB4͕\f[^         */

    while( (i--) != 0 ) {
        temp += value % 10;
        value /= 10;
        temp <<= 4;
    }
    temp += (value % 10 );

    do {
        lcd_put_ch( (temp & 0xf) + '0' );  /* 1\                 */
        temp >>= 4;
    } while( --keta );
}

/************************************************************************/
/* tɐli16ij\                                           */
/* @ long \鐔l, int (1`8)                             */
/* ߂l Ȃ                                                          */
/************************************************************************/
void lcd_put_hex( long value, int keta )
{
    long temp = 0;
    int i = keta-1;
    char c;

    LCD_RS = 1;                         /* DB7`DB4͕\f[^         */

    while( (i--) != 0 ) {
        temp += (value & 0x0f);
        value >>= 4;
        temp <<= 4;
    }
    temp += value & 0xf;

    do {
        c = temp & 0x0f;
        c += (c < 10) ? '0' : ('a'-10);
        lcd_put_ch( c );                /* 1\                    */
        temp >>= 4;
    } while( --keta );
}

/************************************************************************/
/* tɕ\                                                     */
/* @ char *str : ̐擪|C^                              */
/* ߂l Ȃ                                                          */
/************************************************************************/
void lcd_put_str( char *str )
{
    LCD_RS = 1;                         /* DB7`DB4͕\f[^         */

    while(*str != 0) {
        lcd_put_ch( *str );             /* 1M                    */
        str++;
    }
}

/************************************************************************/
/* end of file                                                          */
/************************************************************************/

/*
o
Ver.1.00 2012.04.05 쐬
Ver.1.01 2012.04.27 lcd_put_num֐Alcd_put_hex֐̕sC
*/